unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel3: TPanel;
    PaintBox3: TPaintBox;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    FontDialog1: TFontDialog;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox1: TCheckBox;
    procedure PaintBox3Paint(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private

  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    Info;

{$R *.dfm}

//=============================================================================
//  TFontOutLine
//=============================================================================

//-----------------------------------------------------------------------------
//  ƂȂ array[0..0] of  [1] ŃANZXłȂ
{$RANGECHECKS OFF}

//-----------------------------------------------------------------------------
type
    TPointsArray = array[0..0] of TPoint;
    PPointsArray = ^TPointsArray;
    TTypesArray = array[0..0] of Byte;
    PTypesArray = ^TTypesArray;

//-----------------------------------------------------------------------------
type
    TFontOutLine = class
    private
        FBitmap: TBitmap;
    private
        FText: string;
        FRect: TRect;
        procedure SetText(const Value: string);
    private
        FPtCount: Integer;
        FPoints: PPointsArray;
        FTypes: PTypesArray;
        procedure GetMemory();
        procedure FreeMemory();
    public
        constructor Create();
        destructor Destroy(); override;
    public
        procedure SetCanvas(Source: TCanvas);
        procedure SetFont(Source: TFont);
        procedure SetBrush(Source: TBrush);
        procedure SetPen(Source: TPen);
        property Text: string read FText write SetText;
        property Rect: TRect read FRect;
        property PtCount: Integer read FPtCount;
        property Points: PPointsArray read FPoints;
        property Types: PTypesArray read FTypes;
    end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TFontOutLine.Create();
begin
    inherited;
    FText := '';
    FPtCount := -1;
    FPoints := nil;
    FTypes := nil;
    FRect := Classes.Rect(0, 0, 0, 0);

    FBitmap := TBitmap.Create();
    FBitmap.PixelFormat := pf24bit;

    SetText(FText);
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TFontOutLine.Destroy();
begin
    FBitmap.Free;
    FreeMemory();
    inherited;
end;

//-----------------------------------------------------------------------------
//  m
procedure TFontOutLine.GetMemory();
begin
    //-----------------------------------------------------
    //  pX`_̌擾
    FPtCount := GetPath(FBitmap.Canvas.Handle, FPoints^, FTypes^, 0);

    //-----------------------------------------------------
    //  ̃m
    GetMem(FPoints, SizeOf(TPoint) * FPtCount);
    GetMem(FTypes, SizeOf(Byte) * FPtCount);

    //-----------------------------------------------------
    //  _擾
    GetPath(FBitmap.Canvas.Handle, FPoints^, FTypes^, FPtCount);
end;

//-----------------------------------------------------------------------------
//  J
procedure TFontOutLine.FreeMemory();
begin
    if (FPtCount > 0) then
    begin
        FreeMem(FPoints);
        FreeMem(FTypes);
    end;
end;

//-----------------------------------------------------------------------------
//  LoXɃtHgȂǂ̃vpeBRs[
procedure TFontOutLine.SetCanvas(Source: TCanvas);
begin
    SetFont(Source.Font);
    SetBrush(Source.Brush);
    SetPen(Source.Pen);
end;

//-----------------------------------------------------------------------------
//  LoXɃtHg̃vpeBRs[
procedure TFontOutLine.SetFont(Source: TFont);
begin
    FBitmap.Canvas.Font.Assign(Source);
    SetText(FText);
end;

//-----------------------------------------------------------------------------
//  LoXɃuṼvpeBRs[
procedure TFontOutLine.SetBrush(Source: TBrush);
begin
    FBitmap.Canvas.Brush.Assign(Source);
    SetText(FText);
end;

//-----------------------------------------------------------------------------
//  LoXɃỹvpeBRs[
procedure TFontOutLine.SetPen(Source: TPen);
begin
    FBitmap.Canvas.Pen.Assign(Source);
    SetText(FText);
end;

//-----------------------------------------------------------------------------
//  eLXg󂯎ăAEgC쐬
procedure TFontOutLine.SetText(const Value: string);
var
    DtFormat: Cardinal;
    DtParams: TDrawTextParams;
var
    OldMode: Integer;
begin
    FText := Value;

    //-----------------------------------------------------
    //  p[^
    FillChar(DtParams, SizeOf(DtParams), 0);
    DtParams.cbSize := SizeOf(DtParams);
    DtFormat := DT_LEFT or DT_TOP or DT_SINGLELINE or DT_CALCRECT;
    FRect := Classes.Rect(0, 0, 0, 0);

    //-----------------------------------------------------
    //  `̈挈
    DrawTextEx(FBitmap.Canvas.Handle, PChar(FText), -1, FRect, DtFormat, @DtParams);
    FBitmap.Width := FRect.Right - FRect.Left;
    FBitmap.Height := FRect.Bottom - FRect.Top;

    //  ߂ăp[^ݒ
    DtFormat := DT_LEFT or DT_TOP or DT_SINGLELINE;

    //-----------------------------------------------------
    //  pX쐬
    BeginPath(FBitmap.Canvas.Handle);
    OldMode := SetBkMode(FBitmap.Canvas.Handle, TRANSPARENT);
    DrawTextEx(FBitmap.Canvas.Handle, PChar(FText), -1, FRect, DtFormat, @DtParams);
    SetBkMode(FBitmap.Canvas.Handle, OldMode);
    EndPath(FBitmap.Canvas.Handle);

    //-----------------------------------------------------
    //  AEgC擾
    FreeMemory();
    GetMemory();
end;

//-----------------------------------------------------------------------------
var
    FontOutLine: TFontOutLine = nil;

//=============================================================================
//  UTILITY
//=============================================================================

function PointToRect(const Pt: TPoint): TRect;
begin
    Result.TopLeft := Point(Pt.X - 1, Pt.Y - 1);
    Result.BottomRight := Point(Pt.X + 2, Pt.Y + 2);
end;

//=============================================================================
//=============================================================================

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
    FontOutLine := TFontOutLine.Create();
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    FontOutLine.Free;
end;

//-----------------------------------------------------------------------------
//  AEgC쐬
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    FontOutLine.Text := Edit1.Text;
    FontOutLine.SetFont(FontDialog1.Font);
    Label2.Caption := IntToStr(FontOutLine.PtCount);
    PaintBox3.Repaint();
end;

//-----------------------------------------------------------------------------
//  tHgύX
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
    if FontDialog1.Execute then
    begin
        BitBtn1Click(BitBtn1);
    end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Edit1Change(Sender: TObject);
begin
    if CheckBox1.Checked then
    begin
        BitBtn1Click(BitBtn1);
    end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.PaintBox3Paint(Sender: TObject);
var
    i: Integer;
    Pt: TPoint;
    PtType: Byte;
begin
    //-----------------------------------------------------
    //  Ŝ`
    PaintBox3.Canvas.FillRect(PaintBox3.ClientRect);
    PolyDraw(PaintBox3.Canvas.Handle, FontOutLine.Points[0], FontOutLine.Types[0], FontOutLine.PtCount);

    //-----------------------------------------------------
    //  \_ЂƂ`
    for i := 0 to FontOutLine.PtCount - 1 do
    begin
        Pt := FontOutLine.Points[i];
        PtType := FontOutLine.Types[i];

        case (PtType and not PT_CLOSEFIGURE) of
            PT_MOVETO:
                begin
                    PaintBox3.Canvas.Brush.Color := clBlack;
                    PaintBox3.Canvas.FillRect(PointToRect(Pt));
                end;
            PT_LINETO:
                begin
                    PaintBox3.Canvas.Brush.Color := clRed;
                    PaintBox3.Canvas.FillRect(PointToRect(Pt));
                end;
            PT_BEZIERTO:
                begin
                    PaintBox3.Canvas.Brush.Color := clBlue;
                    PaintBox3.Canvas.FillRect(PointToRect(Pt));
                end;
        end;
    end;
end;

end.

